/***************************************************************************
                          ksplit.cpp  -  description
                             -------------------
    begin                : Fre Apr 27 08:21:56 MEST 2001
    copyright            : (C) 2001 by Christoph Maciejewski
    email                : chrm@chipmail.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <qfileinfo.h>
#include "ksplit.h"
#include "filesizemenue.h"

KSplit::KSplit(QWidget *parent, const char *name) : QWidget(parent, name)
{
  initDialog();
  setAcceptDrops(true);

  longPartSize = 1457664;
  currentPath = QDir::homeDirPath();
  currentPath.append("/");
  errorFlag = 0;
  errorFlagCat = 0;
}

KSplit::~KSplit()
{
}

void KSplit::currentTab (int tab)
{
  cTab = tab;       // Merkt sich den aktuellen Tab.
}

void KSplit::myHomePage(const QString& adress)
{
    KProcess *kfm = new KProcess();
    *kfm << "konqueror" << adress;
    kfm->start( KProcess::DontCare );
    //(void) new KRun (adress);
}

void KSplit::fileOpen()
{
  QString fileToOpen;
  QString homeDir;

  homeDir = QDir::homeDirPath();
  if(currentPath != homeDir) homeDir = currentPath;

  /*if(cTab == 0) fileToOpen =  QFileDialog::getOpenFileName(homeDir, i18n("All files (*.*);;MP3 files (*.mp3);;TGZ files (*.tgz *.tar.gz);;ZIP files (*.zip)"), this, "openFile", i18n("File to split"));
  if(cTab == 1) fileToOpen =  QFileDialog::getOpenFileName(homeDir, i18n("KSplit file (*.saa)"), this, "openFile", i18n("Find KSplit file"));
  if(cTab == 2) fileToOpen =  QFileDialog::getOpenFileName(homeDir, i18n("RAR files (*.rar);;All files (*.*)"), this, "openFile", i18n("Find RAR file"));*/

  if(cTab == 0) fileToOpen =  KFileDialog::getOpenFileName(homeDir, i18n("*.*|All files\n*.mp3|MP3 files\n*.tgz *.tar.gz|TGZ files\n*.zip|ZIP files"), this, i18n("File to split"));
  if(cTab == 1) fileToOpen =  KFileDialog::getOpenFileName(homeDir, i18n("*.saa|KSplit index-file"), this, i18n("Find KSplit file"));
  if(cTab == 2) fileToOpen =  KFileDialog::getOpenFileName(homeDir, i18n("*.rar|RAR files\n*.*|All files"), this, i18n("Find RAR file"));

  if(!fileToOpen.isEmpty())
    {
      if(cTab == 0) Edit1->setText(fileToOpen);
      if(cTab == 1) Edit5->setText(fileToOpen);
      if(cTab == 2) Edit7->setText(fileToOpen);
    }
}

void KSplit::dirOpen()
{
  QString dirToOpen;
  QString homeDir;

  homeDir = QDir::homeDirPath();

  //dirToOpen =  QFileDialog::getExistingDirectory(homeDir,this, "openDir", i18n("Output directory"), TRUE);
  dirToOpen =  KFileDialog::getExistingDirectory(homeDir,this, i18n("Output directory"));

  if(!dirToOpen.isEmpty())
    {
      if(cTab == 0) Edit2->setText(dirToOpen);
      if(cTab == 1) Edit6->setText(dirToOpen);
      if(cTab == 2) Edit8->setText(dirToOpen);
    }
}

void KSplit::calcSize()
{
  /*
  KProcess *ls = new KProcess();

  ls->clearArguments();
  (*ls) << "ls" << "-l" << Edit1->text();

  connect(ls, SIGNAL(receivedStdout(KProcess*, char*, int)), this, SLOT(uebergabe(KProcess*, char*, int)));	
	connect(ls, SIGNAL(receivedStderr(KProcess*, char*, int)), this, SLOT(uebergabe(KProcess*, char*, int)));
	ls->start(KProcess::NotifyOnExit, KProcess::AllOutput);*/
	uebergabe();
}

//void KSplit::uebergabe(KProcess *proc, char *buffer, int buflen)
void KSplit::uebergabe()
{
	QString size;
  int overflow = 0;

  /////////////// alternativ //////////////
  QFileInfo fi1( Edit1->text() );

  uint progres = fi1.size();
  /////////////////////////////////////////

  /*
  QString size(buffer);
  size = size.left( 42 );


  qDebug("Ausgabe"+size);

  long progres;
  int overflow = 0;

  size = size.mid(31,12);
  progres = size.toLong();
  */
  size.setNum(progres);

	Edit3->setText(size);
	
	if(progres > 0)
		{
			Button2->setEnabled(TRUE);
			qDebug("File found: "+Edit1->text());
			qDebug("FileSize: %d", fi1.size());
		}
	if(progres == 0)
		{
			Button2->setEnabled(FALSE);
			qDebug("The file does not exist: "+Edit1->text());
		}
	
	if(progres%longPartSize > 0) overflow = 1;    // Falls noch ein Rest bleibt
  progres = progres/longPartSize + overflow;
  size.setNum(progres);
  Edit4->setText(size);
}

void KSplit::partSize()
{
  int pos;
  pos = Size->currentItem();

  switch(pos)
     {
         case 0: longPartSize = 262144; break;
         case 1: longPartSize = 524288; break;
         case 2: longPartSize = 737280; break;
         case 3: longPartSize = 1048576; break;
         case 4: longPartSize = 1254400; break;
         case 5: longPartSize = 1457664; break;
         case 6: longPartSize = 2097152; break;
         case 7: longPartSize = 2915328; break;
         case 8: longPartSize = 104857600; break;
         case 9: longPartSize = 681574400; break;
         case 10: longPartSize = 734003200; break;
         case 11: anotherSize(); break;
     }

   calcSize();
}

void KSplit::messageWindow(QString title, QString message, int infoType)
{
   info = new QMessageBox( title, message,QMessageBox::Warning,0, 0, 0, this, "info");
   info2 = new QMessageBox( title, message,QMessageBox::Information,0, 0, 0, this, "info");
   if(infoType == 0)info->show();
   if(infoType == 1)info2->show();
}

void KSplit::okPressed()
{
  QString edit2Slash = Edit2->text(); edit2Slash.append("/");   // Slashes erweitern
  QString edit6Slash = Edit6->text(); edit6Slash.append("/");
  QString slash = Edit2->text(); slash = slash.right(1);
  QString slash2 = Edit6->text(); slash2 = slash2.right(1);
  if(slash != "/") Edit2->setText(edit2Slash);
  if(slash2 != "/") Edit6->setText(edit6Slash);

  Button2->setEnabled(FALSE);
  if(cTab == 0) teiler();
  if(cTab == 1) kleber();
  if(cTab == 2) rarUnrar();
}

void KSplit::teiler()
{
   KProcess *splitpr = new KProcess();
   QFileInfo fileInfo(Edit1->text());
   QString fileToSplit = fileInfo.fileName();       // liefert nur den Dateiname zurck

   QString prefix = Edit2->text();                  // Pfad fr die Ausgabe
   prefix.append(fileToSplit);                     // Dateinamen ahngen
   prefix.append("_");
   prefix.append(Edit4->text());                   // Anzahl der Teile ahngen
   prefix.append("part.s");                       // Erweiterung anhngen

   QString partSize;
   partSize.setNum(longPartSize);

   splitpr->clearArguments();

   *splitpr << "split" << "-b" << partSize << Edit1->text() << prefix;

  connect(splitpr, SIGNAL(receivedStdout(KProcess*, char*, int)), this, SLOT(splitMeldung(KProcess*, char*, int)));	
	connect(splitpr, SIGNAL(receivedStderr(KProcess*, char*, int)), this, SLOT(splitMeldung(KProcess*, char*, int)));
	connect(splitpr, SIGNAL(processExited (KProcess*)), this, SLOT(splitExit(KProcess*)));
	
	Edit1->setEnabled(FALSE);
	
	splitpr->start(KProcess::NotifyOnExit, KProcess::AllOutput);
	
	//-------------- Jetzt werden die Skripte erzeugt --------------
	 FILE* fp;
	 int m;
	 QString shellF = Edit2->text(); shellF.append("unsplit.sh");
	 QString batchF = Edit2->text(); batchF.append("unsplit.bat");
	 QString count = Edit4->text();
	 long loop = count.toLong();
	 QString fileParts = fileToSplit;
	 fileParts.append("_"); fileParts.append(Edit4->text()); fileParts.append("part.s");
	 const char* extensions[] = {"aa","ab","ac","ad","ae","af","ag","ah","ai","aj",
	                            "ak","al","am","an","ao","ap","aq","ar","as","at",
	                            "au","av","aw","ax","ay","az","ba","bb","bc","bd"};
	
	 //-------------------------- UNIX -----------------------------
	 if(Shell->isChecked())
	 {
	   fp = fopen(shellF,"wb");
     if(fp != NULL)
     {
       fputs("#! /bin/sh\n#\necho \"--------- KSplit - unsplit file -----------\n\"\ncat ",fp);
       for(m=0; m<loop; m++)
       {
         fputs(("'")+fileParts+extensions[m]+("' "), fp);
       }
       fputs(">'"+fileToSplit+("'"), fp);
       fputs("\necho \"----------------- finished ----------------\"",fp);
       fclose(fp);
     }else errorFlag = 1;
	 }
	
	 //---------------------------- DOS ----------------------------
	 if(Batch->isChecked())
	 {
	   fp = fopen(batchF,"wb");
     if(fp != NULL)
     {
       fputs("@echo off\r\necho --------------- KSplit  - unsplit file -----------\r\ncopy /b \"",fp);
       for(m=0; m<loop-1; m++)
       {
         fputs(fileParts+extensions[m]+("\"+\""), fp);
       }
       fputs(fileParts+extensions[loop-1]+("\""), fp);
       fputs(" \""+fileToSplit+"\"", fp);
       fputs("\r\necho ------------------ finished ----------------",fp);
       fclose(fp);
	   }else errorFlag = 1;
	 }
}

void KSplit::splitMeldung(KProcess *proc, char *buffer, int buflen)
{
  errorFlag = 1;
  QString text(buffer);
  text = text.left(buflen);
  messageWindow(i18n("Split error!"), text, 0);
}

void KSplit::splitExit(KProcess *proc)
{
  if(errorFlag == 0) messageWindow(i18n("Split finished"), i18n("Split finished."), 1);
  if(errorFlag == 1) messageWindow(i18n("Split finished"), i18n("Split finished with error(s)."), 0);

  Edit1->setEnabled(TRUE);
  errorFlag = 0;
}

void KSplit::anotherSize()
{
   long sValue;
   FileSizeMenue sizeEdit;

   sizeEdit.sizeLine->setValue(longPartSize);
   sizeEdit.setCaption( i18n("Another file size...") );
   sizeEdit.show();

   sValue = sizeEdit.sizeLine->value();

   if(sizeEdit.kbytes->isChecked()) sValue = (sizeEdit.sizeLine->value())*1024;
   if(sizeEdit.mbytes->isChecked()) sValue = (sizeEdit.sizeLine->value())*1024*1024;

   longPartSize = sValue;

   calcSize();

}

