/***************************************************************************
                          ksplit.h  -  description
                             -------------------
    begin                : Fre Apr 27 08:21:56 MEST 2001
    copyright            : (C) 2001 by Christoph Maciejewski
    email                : chrm@chipmail.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSPLIT_H
#define KSPLIT_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapp.h>
#include <qwidget.h>

//----------------------- QT Includes ---------------------
#include <qdir.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qpixmap.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qlistbox.h>
#include <qstring.h>
#include <qmessagebox.h>
#include <qpainter.h>
#include <qlayout.h>
#include <qcombobox.h>
#include <qcheckbox.h>
#include <qdialog.h>
#include <qfileinfo.h>
#include <qprogressdialog.h>
#include <qfiledialog.h>
#include <qevent.h>
#include <qdragobject.h>
#include <qfont.h>

//#include <qtabbar.h>


//------------------------ KDE Includes --------------------
#include <ktabctl.h>
#include <kurllabel.h>
#include <kprocess.h>
#include <kseparator.h>
#include <krun.h>
#include <klocale.h>
#include <kfile.h>
#include <kfiledialog.h>


class KSplit : public QWidget
{
  Q_OBJECT
  public:
    /** construtor */
    KSplit(QWidget* parent=0, const char *name=0);
    /** destructor */
    ~KSplit();
  protected:
	void initDialog();
	void dragEnterEvent ( QDragEnterEvent * );
	void dropEvent(QDropEvent *event);
	
	KTabCtl *tabBar;
	
	//QTabBar *tabBar;
	
	QWidget *Buttons;
	QWidget *About;
	QWidget *Split;
	QWidget *Unsplit;
	QWidget *UnRAR;
	
	/*QWidget *Buttons;
	QTab *About;
	QTab *Split;
	QTab *Unsplit;
	QTab *UnRAR;*/
	
	QPushButton *Button1;
	QPushButton *Button2;
	QPushButton *Button3;
	QPushButton *Button4;
	QPushButton *Button5;
	QPushButton *Button6;	
	QPushButton *Button7;
	QPushButton *Button8;
	QPushButton *Button9;
	QPushButton *Button10;
	
	KURLLabel *adress;
	
	QLabel *Birne;	   	
	QLabel *Birne2;
	QLabel *Birne3;
	
	QButtonGroup *Group1;
	QButtonGroup *Group2;
	QButtonGroup *Group3;
	QButtonGroup *Group4;
		
	QListBox *Liste;
	
	QComboBox *Size;
	
	QCheckBox *Shell;
	QCheckBox *Batch;
	QCheckBox *Delete;
	
	QLabel *Text1;
	QLabel *Text2;
	QLabel *Text3;
	QLabel *Text4;
	QLabel *Text5;
	QLabel *Text6;
	QLabel *Text7;
	QLabel *Text8;
	QLabel *Text9;
	QLabel *Text10; 	
	QLabel *Text11;
	QLabel *Text12;
	QLabel *Text13;
	QLabel *Text14;
	QLabel *Text15;
	QLabel *Text16;
	QLabel *Text17;
	QLabel *Text18;
	
	KSeparator *Linie1;
	KSeparator *Linie2;
	KSeparator *Linie3;
	
	QLineEdit *Edit1; 	
	QLineEdit *Edit2; 	
	QLineEdit *Edit3;
	QLineEdit *Edit4;	
	QLineEdit *Edit5;
	QLineEdit *Edit6;
	QLineEdit *Edit7;
	QLineEdit *Edit8;
	QLineEdit *Edit9;
	
	KProcess *ls;
	KProcess *kfm;
	KProcess *splitpr;
	KProcess *unrar;
	KShellProcess *catpr;
	QProgressDialog lpb;
	
	int cTab;
	long longPartSize;
	QString currentPath;
	int errorFlag;
	int errorFlagCat;
	QString textBuffer;
	QMessageBox *info;
	QMessageBox *info2;
	
	public slots:
	void myHomePage(const QString& adress);
	void fileOpen();
	void currentTab (int tab);
	void calcSize();
	//void uebergabe(KProcess *proc, char *buffer, int buflen);
	void uebergabe();
	void partSize();
	void dirOpen();
	void messageWindow(QString title, QString message, int infoType=0);
	void okPressed();
	void teiler();
	void splitMeldung(KProcess *proc, char *buffer, int buflen);
	void splitExit(KProcess *proc);
	
	void kleber();
	void checkFile();
	void catMeldung(KProcess *proc, char *buffer, int buflen);
  void catExit(KProcess *proc);

  void unrarShow();	
  void unrarTest();
  void rarList(KProcess *proc, char *buffer, int buflen);
  void rarExit(KProcess *proc);
  void rarUnrar();
  void rarOutput();  	
  void rarEnableButtons();

  void anotherSize();
	
};

#endif

