/***************************************************************************
                          ksplitdata.cpp  -  description
                             -------------------
    begin                : Mon Jan 1 2001
    copyright            : (C) 2001 by Christoph Maciejewski
    email                : chrm@chipmail.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <kapp.h>
#include "ksplit.h"

void  KSplit::initDialog()
{
  this->setMinimumSize(400,290);
  this->setMaximumSize(400,290);


  Buttons = new QWidget(this); Buttons->setGeometry(0,250,400,35);
  Split = new QWidget(this); Split->setGeometry(0,0,400,255);
	Unsplit = new QWidget(this);Unsplit->setGeometry(0,0,400,255);
	About = new QWidget(this); About->setGeometry(0,0,400,255);
	UnRAR = new QWidget(this); About->setGeometry(0,0,400,255);
	
	/*Split = new QTab("Split"); Split->setGeometry(0,0,400,255);      // Fr spter
	Unsplit = new QTab("Unsplit");Unsplit->setGeometry(0,0,400,255);
	About = new QTab("About"); About->setGeometry(0,0,400,255);
	UnRAR = new QTab("Unrar"); About->setGeometry(0,0,400,255);*/
	
	Button1 = new QPushButton(i18n("Exit"), Buttons,"Exit"); Button1->setGeometry(328,5,70,30);
  Button2 = new QPushButton(i18n("OK"), Buttons,"OK"); Button2->setGeometry(250,5,70,30);
  Button2->setEnabled(FALSE);

  QFont bold("Helvetica", 12, QFont::Bold);
  QFont small("Helvetica", 10);

  //*************************** connects ******************************

  connect( Button1, SIGNAL(clicked()), qApp, SLOT(quit()) );

  //******************************************************************

  //----------------- Build Split-Tab    -----------------
  //Birne= new QLabel(Split,"Birne"); Birne->setPixmap(*IDEA); Birne->setGeometry(25,34,15,15);
  Text5= new QLabel(Split,"text5"); Text5->setText(i18n("File:")); Text5->setGeometry(8,12,50,15);
  Text6= new QLabel(Split,"text6"); Text6->setText(i18n("Output directory:")); Text6->setGeometry(8,60,100,15);

  Text7= new QLabel(Split,"text7"); Text7->setText(i18n("TIP: Use Drag'n Drop to choose a file!")); Text7->setGeometry(45,34,350,15);
  Text7->setFont(small);
  Edit1= new QLineEdit(Split,"splitFile"); Edit1->setGeometry(45,10,300,22);
  Edit1->setAcceptDrops(0);
  Edit2= new QLineEdit(Split,"splitDir"); Edit2->setGeometry(110,58,235,22);
  Edit2->setAcceptDrops(0);

  Button3 = new QPushButton("...", Split,"OpenFile"); Button3->setGeometry(350,10,30,22);
  Button4 = new QPushButton("...", Split,"OpenDir"); Button4->setGeometry(350,58,30,22);
  Group1= new QButtonGroup(Split,"group1"); Group1->setGeometry(10,85,375,128); Group1->setTitle(i18n("Part properties"));

  Text8= new QLabel(Group1,"text8"); Text8->setText(i18n("Size in bytes:")); Text8->setGeometry(8,23,85,15);
  Size= new QComboBox(Group1,"Size"); Size->setGeometry(100,20,260,22);
  Size->insertItem(i18n("262144 (256.00KB)")); Size->insertItem(i18n("524288 (512.00KB)"));
  Size->insertItem(i18n("737280 (DD-Disk)")); Size->insertItem(i18n("1048576 (1.00MB)"));
  Size->insertItem(i18n("1254400 (5.25'' HD-Disk)")); Size->insertItem(i18n("1457664 (3.5'' HD-Disk)"));
  Size->insertItem(i18n("2097152 (2.00MB)")); Size->insertItem(i18n("2915328 (3.5'' ED-Disk)"));
  Size->insertItem(i18n("104857600 (100MB Zip)")); Size->insertItem(i18n("681574400 (650MB CD)"));
  Size->insertItem(i18n("734003200 (700MB CD)")); Size->insertItem(i18n("another..."));
  Size->setCurrentItem(5);
  Shell= new QCheckBox(Group1,"shell");
  Shell->setGeometry(10,48,359,20);
  Shell->setText(i18n("Create Shell-Script (UNIX), for unsplit without KSplit."));

  Batch= new QCheckBox(Group1,"batch");
  Batch->setGeometry(10,69,355,20);
  Batch->setText(i18n("Create Batch-File (DOS), for unsplit without KSplit."));

  Linie1= new KSeparator(Group1,"Linie"); Linie1->setGeometry(10,92,350,3);
  Text9= new QLabel(Group1,"text9"); Text9->setText(i18n("File size:")); Text9->setGeometry(15,100,105,22);
  Text10= new QLabel(Group1,"text10"); Text10->setText(i18n("Number of files:")); Text10->setGeometry(190,100,110,22);
  Edit3= new QLineEdit(Group1,i18n("File size")); Edit3->setGeometry(80,100,80,22); Edit3->setEnabled(FALSE);
  Edit3->setAcceptDrops(0);
  Edit4= new QLineEdit(Group1,i18n("number of parts")); Edit4->setGeometry(300,100,60,22); Edit4->setEnabled(FALSE);
  Edit4->setAcceptDrops(0);

  QString homeDir;
  homeDir = QDir::homeDirPath();
  homeDir.append("/");
  Edit2->setText(homeDir);

  //*********************************** connects ***************************
  connect( Button3, SIGNAL(clicked()), SLOT(fileOpen()) );
  connect( Button4, SIGNAL(clicked()), SLOT(dirOpen()) );
  connect( Edit1, SIGNAL(textChanged(const QString&)), SLOT(calcSize()) );
  connect( Button2, SIGNAL(clicked()), SLOT(okPressed()) );
  connect( Size, SIGNAL(activated(int)), SLOT(partSize()) );
  //************************************************************************


  //----------------- Build UnSplit-Tab  -----------------
  Text11= new QLabel(i18n("File:"), Unsplit,"text11");Text11->setGeometry(8,12,50,15);
  //Birne2= new QLabel(Unsplit,"Birne2"); Birne2->setPixmap(*IDEA); Birne2->setGeometry(25,34,15,15);
  Edit5= new QLineEdit(Unsplit,"unsplitFile"); Edit5->setGeometry(45,10,300,22);
  Edit5->setAcceptDrops(0);
  Text12= new QLabel(i18n("TIP: Use Drag'n Drop to choose the \"*.saa\" file"), Unsplit,"text12"); Text12->setGeometry(45,34,350,15);
  Text12->setFont(small);
  Button5 = new QPushButton(Unsplit,"OpenFile2"); Button5->setGeometry(350,10,30,22); Button5->setText(i18n("..."));
  Edit6= new QLineEdit(Unsplit,"unsplitDir"); Edit6->setGeometry(110,58,235,22);
  Edit6->setAcceptDrops(0);
  Edit6->setText(homeDir);
  Button6 = new QPushButton(Unsplit,"OpenDir2"); Button6->setGeometry(350,58,30,22); Button6->setText(i18n("..."));
  Text13= new QLabel(i18n("Output directory:"), Unsplit,"text13"); Text13->setGeometry(8,60,100,15);
  Group2= new QButtonGroup(Unsplit,"group2"); Group2->setGeometry(10,85,375,128); Group2->setTitle(i18n("Unsplit properties"));
  Liste = new QListBox(Group2,"liste"); Liste->setGeometry(10,60,355,60); Liste->setEnabled(FALSE);
  Delete = new QCheckBox(Group2,"delete"); Delete->setGeometry(10,25,350,20); Delete->setText(i18n("Delete splited files after unsplit."));
  Linie2 = new KSeparator(Group2,"Linie2"); Linie2->setGeometry(10,50,355,3);


  //*********************************** connects ***************************
  connect( Button5, SIGNAL(clicked()), SLOT(fileOpen()) );
  connect( Button6, SIGNAL(clicked()), SLOT(dirOpen()) );
  connect( Edit5, SIGNAL(textChanged(const QString&)), SLOT(checkFile()) );
  //************************************************************************


  //----------------- Build UnRAR-Tab    -----------------
  Text14= new QLabel(i18n("File:"), UnRAR,"text14"); Text14->setGeometry(8,12,50,15);
  Edit7= new QLineEdit(UnRAR,"unRARFile"); Edit7->setGeometry(45,10,300,22);
  Edit7->setAcceptDrops(0);
  //Birne3= new QLabel(UnRAR,"Birne3"); Birne3->setPixmap(*IDEA); Birne3->setGeometry(25,34,15,15);
  Text15= new QLabel(i18n("TIP: Use Drag'n Drop to choose the \"*.rar\" file"), UnRAR,"text15"); Text15->setGeometry(45,34,350,15);
  Text15->setFont(small);
  Edit8= new QLineEdit(UnRAR,"unRARDir"); Edit8->setGeometry(110,58,235,22);
  Edit8->setAcceptDrops(0);
  Edit8->setText(homeDir);
  Text16= new QLabel(i18n("Output directory:"), UnRAR,"text16"); Text16->setGeometry(8,60,100,15);
  Button7 = new QPushButton(UnRAR,"OpenFile3"); Button7->setGeometry(350,10,30,22); Button7->setText(i18n("..."));
  Button8 = new QPushButton(UnRAR,"OpenDir3"); Button8->setGeometry(350,58,30,22); Button8->setText(i18n("..."));
  Group3= new QButtonGroup(UnRAR,"group3"); Group3->setGeometry(10,85,375,128); Group3->setTitle(i18n("UnRAR properties"));
  Text17= new QLabel(i18n("Archive password:"), Group3,"text17"); Text17->setGeometry(15,23,130,15);
  Edit9= new QLineEdit(Group3,"Password"); Edit9->setGeometry(150,20,125,22); Edit9->setEchoMode(QLineEdit::Password);
  Edit9->setAcceptDrops(0);
  Linie3 = new KSeparator(Group3,"Linie3"); Linie3->setGeometry(10,50,355,3);
  Button9 = new QPushButton(Group3,"Test"); Button9->setGeometry(100,65,180,22); Button9->setText(i18n("Test archive files"));
  Button9->setEnabled(FALSE);
  Button10 = new QPushButton(Group3,"Liste"); Button10->setGeometry(100,90,180,22); Button10->setText(i18n("List contents of archive"));
  Button10->setEnabled(FALSE);

  //*********************************** connects ***************************
  connect( Button7, SIGNAL(clicked()), SLOT(fileOpen()) );
  connect( Button8, SIGNAL(clicked()), SLOT(dirOpen()) );
  connect( Edit7, SIGNAL(returnPressed()), SLOT(unrarShow()) );
  connect( Edit7, SIGNAL(textChanged ( const QString& )), SLOT(rarEnableButtons()) );
  connect( Button9, SIGNAL(clicked()), SLOT(unrarTest()) );
  connect( Button10, SIGNAL(clicked()), SLOT(unrarShow()) );
  //************************************************************************

  //----------------- Build About-Tab    -----------------
  Group4= new QButtonGroup(About,"group4"); Group4->setGeometry(10,10,375,203); Group4->setTitle("");
  Text3= new QLabel(About,"unsplit"); Text3->setFont(QFont("helvetica", 17, 50));
  Text3->setText("KSplit"); Text3->setAlignment(AlignCenter);
  Text3->setGeometry(20,40,360,30);
  Text4= new QLabel(About,"unsplit"); Text4->setFont(QFont("helvetica", 12, 50));
  Text4->setText("Version 0.5.4\n\n(c)2002 by Christoph Maciejewski"); Text4->setAlignment(AlignCenter);
  Text4->setGeometry(20,65,360,60);
  adress = new KURLLabel(About);
  adress->setGeometry(20,130,360,14);
  adress->setAlignment(AlignCenter);
  adress->setText("http://www.christophm.purespace.de");
  adress->setURL("http://www.christophm.purespace.de");
  adress->setUnderline(false);
  adress->setGlow(false);
  adress->setFloat(true);

  connect(adress, SIGNAL(leftClickedURL(const QString&)), SLOT(myHomePage(const QString&)));

  //----------------- Build UI with Tabs -----------------
  tabBar = new KTabCtl(this);

  //tabBar = new QTabBar(this);

	tabBar->setGeometry(0,0,400,250);
	tabBar->addTab(Split, i18n("   &Split   "));
	tabBar->addTab(Unsplit, i18n("   &Unsplit   "));
	tabBar->addTab(UnRAR, i18n("  Un&RAR  "));
	tabBar->addTab(About, i18n("   &About   "));
	
	tabBar->setFocusPolicy(QWidget::ClickFocus);
	
	connect( tabBar, SIGNAL(tabSelected (int)), SLOT(currentTab(int)) );   	
}
