/***************************************************************************
                          kunsplit.cpp  -  description
                             -------------------
    begin                : Sun Jan 7 2001
    copyright            : (C) 2001 by Christoph Maciejewski
    email                : chrm@chipmail.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ksplit.h"

void KSplit::kleber()
{
  KShellProcess *catpr = new KShellProcess();
  unsigned int m;
  int len;
  QString removExt;


  QString fileName = ">'";    						// ">'"  - Hochkomme wg. Sonderzeichen!
  fileName.append(Edit6->text());       // ">'/home/"
  fileName.append(Liste->text(0));      // ">'/home/datei.mp3_xpart.saa"
  removExt = fileName.right(10);				// "_xpart.saa"
  removExt = removExt.left(1);

  if(removExt == "_") {len = 10;}else len = 11;
  fileName = fileName.left(fileName.length()-len);

  QFileInfo fi(Edit5->text());
  QString parts = fi.dirPath(TRUE);   	// Directory
  parts.append("/");

  *catpr << "cat";
    		
  for(m = 0; m < Liste->count(); m++)
  {
    *catpr << ("'" + parts+Liste->text(m) + "'");
  }

  *catpr << (fileName + "'");

  connect(catpr, SIGNAL(receivedStdout(KProcess*, char*, int)), this, SLOT(catMeldung(KProcess*, char*, int)));	
	connect(catpr, SIGNAL(receivedStderr(KProcess*, char*, int)), this, SLOT(catMeldung(KProcess*, char*, int)));
	connect(catpr, SIGNAL(processExited (KProcess*)), this, SLOT(catExit(KProcess*)));
	catpr->start(KProcess::NotifyOnExit, KProcess::AllOutput);
		
}

void KSplit::checkFile()
{
   QFileInfo fi(Edit5->text());             // Dateiname
   QString file = Edit5->text();
   QString searchCriteria = fi.fileName();
   searchCriteria = searchCriteria.left(searchCriteria.length()-2);
   searchCriteria.append("*");

   QString path = fi.dirPath(TRUE);         // Vezeichnis->hier werden die anderen gesucht!

   unsigned int i;
   QDir d;                                  // Speichert die Namen der Dateien

   d.cd(path);
   d.setNameFilter(searchCriteria);
   Liste->clear();

   if(fi.exists())
   {
    if(file.right(3) == "saa")
    {
     Button2->setEnabled(TRUE);        // 'OK'-Button wird freigeschaltet
     if(d.count() > 0)
      {
        for ( i=0; i<d.count(); i++ )       // Liste wird mit Treffern gefllt
        {
          Liste->insertItem(d[i]);
        }
      }else Button2->setEnabled(FALSE);
     }
    }
}

void KSplit::catMeldung(KProcess *proc, char *buffer, int buflen)
{
  errorFlagCat = 1;
  QString text(buffer);
  text = text.left(buflen);
  messageWindow(i18n("Unsplit error!"), text);
  errorFlagCat = 0;
}

void KSplit::catExit(KProcess *proc)
{
  unsigned int m;
  QDir del;
  QFileInfo fi(Edit5->text());             // Dateiname
  QString path = fi.dirPath(TRUE);         // Vezeichnis->hier werden die files gelscht
  del.cd(path);

  if(errorFlagCat == 0)
  {
    messageWindow(i18n("Unsplit finished"), i18n("Unsplit finished."), 1);
    Button2->setEnabled(FALSE);               // Zur Sicherheit sperren -> sonst GEFAHR!
    if(Delete->isChecked())
	  {
	    for(m = 0; m < Liste->count(); m++)       // lscht dei Dateien
      {
        del.remove(Liste->text(m));
      }	    	
	  }
  }
}
