/***************************************************************************
                          unrar.cpp  -  description
                             -------------------
    begin                : Sun Jan 7 2001
    copyright            : (C) 2001 by Christoph Maciejewski
    email                : chrm@chipmail.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "ksplit.h"
#include "bigoutput.h"


void KSplit::unrarShow()
{
  KProcess *unrar = new KProcess();
  unrar->clearArguments();
  (*unrar) << "unrar" << "l" << Edit7->text();

  textBuffer = ("");

  connect(unrar, SIGNAL(receivedStdout(KProcess*, char*, int)), this, SLOT(rarList(KProcess*, char*, int)));	
	connect(unrar, SIGNAL(receivedStderr(KProcess*, char*, int)), this, SLOT(rarList(KProcess*, char*, int)));
	connect(unrar, SIGNAL(processExited (KProcess*)), this, SLOT(rarExit(KProcess*)));
	unrar->start(KProcess::NotifyOnExit, KProcess::AllOutput);
}

void KSplit::unrarTest()
{
  KProcess *unrar = new KProcess();
  unrar->clearArguments();
  QString password(Edit9->text());

  lpb.setLabelText(i18n("Please wait..."));
  lpb.setCancelButtonText (i18n("Cancel"));
  lpb.show();

  if(strlen(Edit9->text()) == 0) password = "xxx";
  password = "-p" + password;

  (*unrar) << "unrar" << "t" << password << Edit7->text();

  textBuffer = ("");

  connect(unrar, SIGNAL(receivedStdout(KProcess*, char*, int)), this, SLOT(rarList(KProcess*, char*, int)));	
	connect(unrar, SIGNAL(receivedStderr(KProcess*, char*, int)), this, SLOT(rarList(KProcess*, char*, int)));
	connect(unrar, SIGNAL(processExited (KProcess*)), this, SLOT(rarExit(KProcess*)));
	unrar->start(KProcess::NotifyOnExit, KProcess::AllOutput);
}

void KSplit::rarList(KProcess *proc, char *buffer, int buflen)
{
  QString size(buffer);
  size = size.left(buflen);   // Bei Fehlern buflen + 1 sezten!

  QString progress = size.mid(5, size.length()-6);
  long intProgress = progress.toLong();

  lpb.setProgress(intProgress);
  textBuffer = textBuffer + size;
}

void KSplit::rarExit(KProcess *proc)
{
  lpb.reset();
  rarOutput();
}

void KSplit::rarUnrar()
{
  KProcess *unrar = new KProcess();
  unrar->clearArguments();
  QString password(Edit9->text());

  lpb.setLabelText(i18n("Please wait..."));
  lpb.setCancelButtonText (i18n("Cancel"));
  lpb.show();

  if(strlen(Edit9->text()) == 0) password = "mp3hitz";   // Default password ;-)
  password = "-p" + password;

  (*unrar) << "unrar" << "x" << "-o+" << password << Edit7->text() << Edit8->text();

  textBuffer = ("");

  connect(unrar, SIGNAL(receivedStdout(KProcess*, char*, int)), this, SLOT(rarList(KProcess*, char*, int)));	
	connect(unrar, SIGNAL(receivedStderr(KProcess*, char*, int)), this, SLOT(rarList(KProcess*, char*, int)));
	connect(unrar, SIGNAL(processExited (KProcess*)), this, SLOT(rarExit(KProcess*)));
	unrar->start(KProcess::NotifyOnExit, KProcess::AllOutput);
}

void KSplit::rarOutput()
{
   bigoutput output;

   output.QMultiLineEdit_1->setText(textBuffer);
   output.setCaption( i18n("UnRAR output:") );
   output.show();

}

void KSplit::rarEnableButtons()
{
  Button9->setEnabled(TRUE);
  Button10->setEnabled(TRUE);
  Button2->setEnabled(TRUE);
}
